// Copyright (c) 2017, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by an AGPL-3.0-style license
// that can be found in the LICENSE file.

part of expr;

/// Reduce mapping [m] to a mapping from unique pattern IDs to one expressions.
Mapping getPatternMapping(Mapping m) {
  final pMapping = new Mapping();
  m.forEach((source, targets) {
    // See if a pattern with the same ID already exits.
    if (source.first.type == ExprType.pattern) {
      final patternId = source.first.value;
      for (final from in pMapping.keys) {
        if (from.first.value == patternId) {
          return;
        }
      }
      pMapping.add(new Transform(source, targets.first));
    }
  });
  return pMapping;
}
