// Copyright (c) 2017, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by an AGPL-3.0-style license
// that can be found in the LICENSE file.

part of expr;

/// Operator associativity in the case of nesting
/// (left-to-right or right-to-left)
enum Associativity { ltr, rtl }

/// Operator notation type (prefix: `-1`, infix: `1+1`, postfix: `1!`)
enum OperatorNotation { prefix, infix, postfix }

/// Information about a single operator type
class Operator {
  final int id;
  final int functionId;
  final int precedenceLevel;
  final List<String> symbols;
  final OperatorNotation notation;
  final Associativity associativity;

  Operator(this.functionId, this.precedenceLevel, this.symbols, this.notation,
      this.associativity,
      {this.id});
}
