// Copyright (c) 2017, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by an AGPL-3.0-style license
// that can be found in the LICENSE file.

library expr.test.helpers;

import 'package:expr/expr.dart';

/// Helper to create a substitute rewrite for the given [input]. This can be
/// either a [Transform] or a [TrueStatement].
Rewrite rewriteSubstitute(int index, input) {
  final st = input is Transform
      ? new TrueStatement(new Formula([], input), [])
      : (input is TrueStatement ? input : null);
  return new Rewrite(index, RewriteInstruction.substitute, statement: st);
}
