// Copyright (c) 2017, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by an AGPL-3.0-style license
// that can be found in the LICENSE file.

library expr.test.matchers;

import 'package:test/test.dart';

/// Dirty approach to get a clean looking exception/error matcher.
class _MessageMatcher extends TypeMatcher {
  final String message;
  const _MessageMatcher(this.message) : super('Object');

  @override
  bool matches(item, matchState) => item.toString().contains(message);

  @override
  Description describe(Description description) =>
      description..add('Object:<$message>');
}

/// Check if an object with the given message was thrown.
Matcher thrws(String message) {
  return throwsA(new _MessageMatcher(message));
}
